Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 433647 - sci-libs/netcdf-4.1.3 fails with -l-L/usr/lib/gcc/x86_64-pc...
Summary: sci-libs/netcdf-4.1.3 fails with -l-L/usr/lib/gcc/x86_64-pc...
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Gentoo Science Related Packages
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2012-09-01 11:59 UTC by Juergen Rose
Modified: 2013-12-01 18:21 UTC (History)
0 users

See Also:
Package list:
Runtime testing required: ---


Attachments
/var/tmp/portage/sci-libs/netcdf-4.1.3/temp/build.log (build.log,96.32 KB, text/plain)
2012-09-01 11:59 UTC, Juergen Rose
Details
/usr/local/portage/sci-libs/netcdf/netcdf-4.1.3.ebuild (netcdf-4.1.3.ebuild,2.08 KB, text/plain)
2012-10-08 10:40 UTC, Juergen Rose
Details
/usr/local/portage/sci-libs/netcdf/files/netcdf-postdeps.patch (netcdf-postdeps.patch,963 bytes, text/plain)
2012-10-08 10:41 UTC, Juergen Rose
Details
/usr/local/portage/sci-libs/netcdf/netcdf-4.1.3.ebuild (netcdf-4.1.3.ebuild,2.11 KB, text/plain)
2012-10-08 12:23 UTC, Juergen Rose
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Juergen Rose 2012-09-01 11:59:17 UTC
Created attachment 322717 [details]
/var/tmp/portage/sci-libs/netcdf-4.1.3/temp/build.log

paraview-3.14.1-r2 wants to downgrade netcdf to version 4.1.3, which is really very old, it was replaced in april by version 4.2:

root@caiman:/usr/src(86)# emerge -pvuDNt world

These are the packages that would be merged, in reverse order:

Calculating dependencies... done!
[ebuild     U #] sci-visualization/paraview-3.14.1-r2::science [3.14.1-r1::science] USE="boost doc examples ffmpeg gui mpi mysql plugins python theora webkit -cg -coprocessing -nvcontrol" 26,249 kB
[ebuild     UD ]  sci-libs/netcdf-4.1.3 [4.2.1.1] USE="cxx%* doc fortran%* hdf5 -dap* -static-libs (-examples%*) (-hdf%*) (-mpi%*) (-szip%*) (-test%) (-tools%*)" 0 kB

Total: 2 packages (1 upgrade, 1 downgrade), Size of downloads: 26,249 kB

WARNING: One or more updates have been skipped due to a dependency conflict:

sci-libs/netcdf:0

  (sci-libs/netcdf-4.2.1.1::gentoo, ebuild scheduled for merge) conflicts with
    ~sci-libs/netcdf-4.1.3[cxx,hdf5] required by (sci-visualization/paraview-3.14.1-r2::science, ebuild scheduled for merge)



root@caiman:/root(11)# genlop -t netcdf | tail -n 12
     Fri Aug  5 08:22:03 2011 >>> sci-libs/netcdf-4.1.3
       merge time: 1 minute and 22 seconds.

     Thu Apr 19 02:10:37 2012 >>> sci-libs/netcdf-4.2
       merge time: 46 seconds.

     Sun May 13 11:27:50 2012 >>> sci-libs/netcdf-4.2
       merge time: 26 seconds.

     Sat Aug 25 16:07:41 2012 >>> sci-libs/netcdf-4.2.1.1
       merge time: 45 seconds.


But the installation of netcdf-4.1.3 fails with:

....

/var/tmp/portage/sci-libs/netcdf-4.1.3/work/netcdf-4.1.3/include/netcdf.h:1539:1: note: expected 'long long int *' but argument is of type 'int *'
/bin/sh ../libtool --tag=FC   --mode=link mpif90  -O2 -pipe  -version-number 5:1:0  -Wl,-O1 -Wl,--as-needed -o libnetcdff.la -rpath /usr/lib64 fort-attio.lo fort-control.lo fort-dim.lo fort-genatt.lo fort-geninq.lo fort-genvar.lo fort-lib.lo fort-misc.lo fort-v2compat.lo fort-vario.lo fort-var1io.lo fort-varaio.lo fort-varmio.lo fort-varsio.lo fort-nc4.lo ../liblib/libnetcdf.la ../f90/libnetcdff90.la -lsz -lhdf5_hl -lhdf5 -lm -lz -lcurl 
libtool: link: mpif90 -shared  -fPIC  .libs/fort-attio.o .libs/fort-control.o .libs/fort-dim.o .libs/fort-genatt.o .libs/fort-geninq.o .libs/fort-genvar.o .libs/fort-lib.o .libs/fort-misc.o .libs/fort-v2compat.o .libs/fort-vario.o .libs/fort-var1io.o .libs/fort-varaio.o .libs/fort-varmio.o .libs/fort-varsio.o .libs/fort-nc4.o  -Wl,--whole-archive ../f90/.libs/libnetcdff90.a -Wl,--no-whole-archive  -Wl,-rpath -Wl,/var/tmp/portage/sci-libs/netcdf-4.1.3/work/netcdf-4.1.3_build/liblib/.libs -Wl,--as-needed ../liblib/.libs/libnetcdf.so -lsz -lhdf5_hl -lhdf5 -lz -lcurl -L/usr/lib64 -L/usr/lib/gcc/x86_64-pc-linux-gnu/4.6.3 -l -L/usr/lib/gcc/x86_64-pc-linux-gnu/4.6.3/../../../../lib64 -L/lib/../lib64 -L/usr/lib/../lib64 -L/usr/lib/gcc/x86_64-pc-linux-gnu/4.6.3/../../../../x86_64-pc-linux-gnu/lib -L/usr/lib/gcc/x86_64-pc-linux-gnu/4.6.3/../../.. /usr/lib64/libmpi_f90.so /usr/lib64/libmpi_f77.so /usr/lib64/libmpi.so -lrt -lnsl -lutil -lhwloc -ldl /usr/lib/gcc/x86_64-pc-linux-gnu/4.6.3/libgfortran.so /usr/lib/gcc/x86_64-pc-linux-gnu/4.6.3/libquadmath.so -lm -lpthread -lc -lgcc_s  -O2 -Wl,-O1   -pthread -Wl,-soname -Wl,libnetcdff.so.5 -o .libs/libnetcdff.so.5.1.0
/usr/lib/gcc/x86_64-pc-linux-gnu/4.6.3/../../../../x86_64-pc-linux-gnu/bin/ld: cannot find -l-L/usr/lib/gcc/x86_64-pc-linux-gnu/4.6.3/../../../../lib64
collect2: ld returned 1 exit status
make[3]: *** [libnetcdff.la] Error 1
...
>>> Failed to emerge sci-libs/netcdf-4.1.3, Log file:



root@caiman:/usr/src(87)# emerge --info '=sci-libs/netcdf-4.1.3'
Portage 2.1.11.12 (default/linux/amd64/10.0, gcc-4.6.3, glibc-2.15-r2, 3.5.2-gentoo x86_64)
=================================================================
                        System Settings
=================================================================
System uname: Linux-3.5.2-gentoo-x86_64-AMD_Phenom-tm-_II_X6_1090T_Processor-with-gentoo-2.2
Timestamp of tree: Sat, 01 Sep 2012 10:00:01 +0000
app-shells/bash:          4.2_p37
dev-java/java-config:     2.1.12
dev-lang/python:          2.7.3-r2, 3.2.3-r1
dev-util/cmake:           2.8.9
dev-util/pkgconfig:       0.27.1
sys-apps/baselayout:      2.2
sys-apps/openrc:          0.10.5
sys-apps/sandbox:         2.6
sys-devel/autoconf:       2.13, 2.69
sys-devel/automake:       1.9.6-r3, 1.10.3, 1.11.6, 1.12.3
sys-devel/binutils:       2.22.90
sys-devel/gcc:            4.5.3-r2, 4.6.3
sys-devel/gcc-config:     1.7.3
sys-devel/libtool:        2.4.2
sys-devel/make:           3.82-r3
sys-kernel/linux-headers: 3.5 (virtual/os-headers)
sys-libs/glibc:           2.15-r2
Repositories: gentoo x11 bicatali science dilfridge java-overlay sunrise lisp x-portage x-cpan x-g-octave
ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="* -@EULA PUEL Intel-SDP dlj-1.1 skype-eula skype-4.0.0.7-copyright googleearth AdobeFlash-10.3 cadsoft Oracle-BCLA-JavaSE"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=amdfam10 -O2 -pipe"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/config /usr/share/gnupg/qualified.txt /usr/share/openvpn/easy-rsa /var/lib/hsqldb"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/php/apache2-php5.3/ext-active/ /etc/php/apache2-php5.4/ext-active/ /etc/php/cgi-php5.3/ext-active/ /etc/php/cgi-php5.4/ext-active/ /etc/php/cli-php5.3/ext-active/ /etc/php/cli-php5.4/ext-active/ /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-march=amdfam10 -O2 -pipe"
DISTDIR="/usr/portage/distfiles"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-logs config-protect-if-modified distlocks ebuild-locks fixlafiles news parallel-fetch parse-eapi-ebuild-head protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch xattr"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://distfiles.gentoo.org"
LANG="en_US.UTF-8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
LINGUAS="de fr ru"
MAKEOPTS="-j7"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
PORTDIR_OVERLAY="/var/lib/layman/x11 /var/lib/layman/bicatali /var/lib/layman/science /var/lib/layman/dilfridge /var/lib/layman/java-overlay /var/lib/layman/sunrise /var/lib/layman/lisp /usr/local/portage /var/lib/cpan /var/lib/g-octave"
SYNC="rsync://rsync.gentoo.org/gentoo-portage"
USE="3dnow 3dnowext 64bit Intel-SDP R X Xaw3d a52 aac acl acpi admin afs alsa amd64 ao apache2 apng applet archive arpack asf aspell assistant atlas audacious audiofile automap automount bash-completion berkdb blas blast bluetooth bluray boo boost bzip2 cairo cdda cddb cdf cdio cdparanoia cdr cgi chm cli consolekit corba cracklib crypt css cups curl cxx daap db dbi dbm dbus declarative designer devhelp device-mapper dga dia dirac djvu doc dot dri ds2490 ds9097 ds9097u dts dv dvb dvd dvdr dvi dynamicplugin eds egl elf emacs emboss emf encode epiphany evo examples exif expat extensions extra extras faac faad ffmpeg fftw firefox fits flac fltk fontconfig foomaticdb fortran fortran95 fpx fts3 fuse g3dvl galago gcj gd gdal gdbm gdu gedit geoip geolocation geos gfortran gif gimp git glade glib glpk gml gmp gnome gnome-keyring gnome-print gnuplot gnutls gphoto2 gpm grammar graphics graphtft graphviz grass gsl gsm gstreamer gtk gtk3 gudev guile harness hddtemp hdf hdf5 hdri http httpd hvm hwdb iconv icq icu id3 imagemagick imap inotify ipod ipv6 irda ithreads jabber jadetex java java6 jbig john jpeg jpeg2k kate kdepim kdrive kerberos kpathsea kqemu kvm ladspa lame lapack latex lcms ldap lensfun libffi libkms libnotify libsamplerate live lm_sensors lua lzo mad mail maildir mapnik math matroska media-library mkl mmx mmxext mng modules mono motif mozilla mp3 mp4 mpeg mpi mplayer mtp mudflap multilib musepack musicbrainz mysql mysqli nautilus ncurses netcdf netpbm network networking networkmanager nfs nls nntp nptl nsplugin ntfs ntp numpy obex objc ocaml ocr octave odbc ogdi ogg openexr opengl openmp overview pam pcre pda pdf perl plotutils plugins png podcast policykit portaudio posix postgres postscript ppds pppd preview-latex proj projectm projectx pstricks pulseaudio python python-bindings q16 q32 qemu qhull qt3support qt4 quicktime readline reiserfs reports rle romio rpc rrdcgi rrdtool sage samba sasl schroedinger science sdk sdl secure-delete semantic-desktop server session shout sip slang slp smbclient smp sms sndfile snmp soup sox speex spell sql sqlite sse sse2 sse4a ssl stlport subtitles subversion suexec svg svm swig szip t1lib tcl tcpd tex tex4ht texmacs tgif theora thesaurus threads thunderbird tidy tiff tk toolbar tools truetype udev unicode usb userlocales utempter vaapi video virtualbox visio vorbis wav webdav webdav-serf webkit wmf wxwidgets x264 xa xattr xcb xemacs xetex xext xft xine xml xmlreader xmlrpc xpm xv xvid xvmc yaml zlib zvbi" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" ALSA_PCM_PLUGINS="adpcm alaw asym copy dmix dshare dsnoop empty extplug file hooks iec958 ioplug ladspa lfloat linear meter mmap_emul mulaw multi null plug rate route share shm softvol" APACHE2_MODULES="actions alias auth_basic auth_digest authn_anon authn_dbd authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgid dav dav_fs dav_lock dbd deflate dir disk_cache env expires ext_filter file_cache filter headers ident imagemap include info log_config logio mem_cache mime mime_magic negotiation proxy proxy_ajp proxy_balancer proxy_connect proxy_http rewrite setenvif so speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump" CAMERAS="canon fuji ptp2" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CURL_SSL="nss" DRACUT_MODULES="caps lvm mdraid syslog" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ubx" INPUT_DEVICES="keyboard mouse evdev" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LINGUAS="de fr ru" NETBEANS_MODULES="apisupport cnd dlight enterprise ergonomics groovy gsf harness ide identity j2ee java mobility nb php profiler ruby websvccommon xml" PHP_TARGETS="php5-3" PYTHON_TARGETS="python3_2 python2_7" QEMU_SOFTMMU_TARGETS="arm i386 x86_64" QEMU_USER_TARGETS="arm i386 x86_64" RUBY_TARGETS="ruby18 ruby19" USERLAND="GNU" VIDEO_CARDS="radeon vesa" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CPPFLAGS, CTARGET, EMERGE_DEFAULT_OPTS, INSTALL_MASK, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, USE_PYTHON

root@caiman:/usr/src(88)# emerge -pqv '=sci-libs/netcdf-4.1.3'
[ebuild     UD] sci-libs/netcdf-4.1.3 [4.2.1.1] USE="cxx%* doc fortran%* hdf5 -dap* -static-libs (-examples%*) (-hdf%*) (-mpi%*) (-szip%*) (-test%) (-tools%*)"
Comment 1 François Bissey 2012-09-03 21:39:01 UTC
Yes I got that too Juergen. I had to switched to gcc-4.5.x to compile netcdf. I slacked in not filling the bug myself. It is a rather strange flag problem and I don't have the expertise for it. For info the exact same thing happens with netcdf-4.1.1-r4.
Just to set the record straight on this, paraview ship with netcdf-4.1.2 (not in portage). Paraview won't compile against netcdf-4.1.1-r4 or 4.2+. Just 4.1.3.
Comment 2 Justin Lecher (RETIRED) gentoo-dev 2012-09-04 09:18:26 UTC
Do we really need that version of netcdf for paraview? Can't we patch paraviewto support newer netcdf?

It seems there is some automagic to use mpi in this version of netcdf
Comment 3 François Bissey 2012-09-04 09:20:54 UTC
(In reply to comment #2)
> Do we really need that version of netcdf for paraview? Can't we patch
> paraviewto support newer netcdf?
> 
> It seems there is some automagic to use mpi in this version of netcdf

Well it is using the c++ interface, and more and more c++ makes me want to vomit.
Comment 4 François Bissey 2012-09-04 09:27:28 UTC
OK, the first thing about it now that I thought a little bit about it is that the c++ headers are split in netcdf-4.2 - vtk/paraview only look at netcdfcpp.h. Getting the headers in would be the first step. If we are lucky that may be enough.
Comment 5 Justin Lecher (RETIRED) gentoo-dev 2012-09-04 09:31:19 UTC
What about sci-libs/netcdf-cxx?
Comment 6 François Bissey 2012-09-04 09:39:51 UTC
OK - I gave a go at 4.2 on Friday and I used both netcdf and netcdf-cxx, that's why I can talk about netcdfcpp.h being split. You would expect it to be in netcdf-cxx but it isn't, there is a number of headers instead if I remember well.
Comment 7 François Bissey 2012-09-04 10:54:24 UTC
Had another look at using 4.2 patching for the appropriate netcdf-cxx headers but I am not going anywhere with that:

[ 23%] Building CXX object VTK/IO/CMakeFiles/vtkIO.dir/vtkMPASReader.cxx.o
cd /scratch/portage/sci-visualization/paraview-3.14.1-r2/work/paraview-3.14.1_build/VTK/IO && /usr/bin/x86_64-pc-linux-gnu-g++  -DvtkIO_EXPORTS -DVTK_PYTHON_BUILD -DVTK_IN_VTK  -DNDEBUG -O1 -march=native -pipe -ggdb  -Wno-deprecated  -Wno-deprecated -fPIC -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/paraview-3.14.1_build -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/paraview-3.14.1_build/VTK/Utilities -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/paraview-3.14.1_build/VTK -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/paraview-3.14.1_build/VTK/Common -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/paraview-3.14.1_build/VTK/VolumeRendering -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/paraview-3.14.1_build/VTK/Rendering -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/paraview-3.14.1_build/VTK/Charts -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/paraview-3.14.1_build/VTK/Chemistry -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/paraview-3.14.1_build/VTK/Utilities/vtkalglib -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Wrapping/Python -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/paraview-3.14.1_build/VTK/Wrapping/Python -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Infovis -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/TextAnalysis -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Geovis -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Views -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Parallel -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/VolumeRendering -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Hybrid -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Widgets -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Rendering -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Charts -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Chemistry -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Rendering/Testing/Cxx -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/IO -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Imaging -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Graphics -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/GenericFiltering -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Filtering -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Common -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Utilities -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Common/Testing/Cxx -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/paraview-3.14.1_build/VTK/Utilities/vtklibproj4 -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Utilities/vtklibproj4 -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/paraview-3.14.1_build/VTK/Utilities/DICOMParser -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Utilities/DICOMParser -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/paraview-3.14.1_build/VTK/Utilities/LSDyna -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Utilities/LSDyna -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/paraview-3.14.1_build/VTK/Utilities/MaterialLibrary -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Utilities/MaterialLibrary -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/paraview-3.14.1_build/VTK/Utilities/vtkmetaio -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Utilities/vtkmetaio -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/paraview-3.14.1_build/VTK/Utilities/verdict -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Utilities/verdict -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/paraview-3.14.1_build/VTK/Utilities/Cosmo -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Utilities/Cosmo -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/paraview-3.14.1_build/VTK/Utilities/VPIC -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Utilities/VPIC -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Utilities/utf8/source -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/GUISupport/Qt -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/paraview-3.14.1_build/VTK/GUISupport/Qt -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/GUISupport/Qt/Chart -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/paraview-3.14.1_build/VTK/GUISupport/Qt/Chart -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Utilities/vtkalglib -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/Utilities/ftgl/src -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/paraview-3.14.1_build/VTK/Utilities/ftgl -I/usr/include/libxml2 -I/usr/include/freetype2 -I/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/paraview-3.14.1_build/VTK/IO -I/usr/include/mysql -I/usr/include/python2.7    -fvisibility=hidden -fvisibility-inlines-hidden -o CMakeFiles/vtkIO.dir/vtkMPASReader.cxx.o -c /scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/IO/vtkMPASReader.cxx
/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/IO/vtkMPASReader.cxx:129:3: error: 'NcFile' does not name a type
/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/IO/vtkMPASReader.cxx:130:3: error: 'NcVar' does not name a type
/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/IO/vtkMPASReader.cxx:131:3: error: 'NcVar' does not name a type
/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/IO/vtkMPASReader.cxx: In constructor 'vtkMPASReader::Internal::Internal()':
/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/IO/vtkMPASReader.cxx:113:5: error: class 'vtkMPASReader::Internal' does not have any field named 'ncFile'
/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/IO/vtkMPASReader.cxx:117:13: error: 'class vtkMPASReader::Internal' has no member named 'cellVars'
/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/IO/vtkMPASReader.cxx:118:13: error: 'class vtkMPASReader::Internal' has no member named 'pointVars'
/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/IO/vtkMPASReader.cxx: In destructor 'vtkMPASReader::Internal::~Internal()':
/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/IO/vtkMPASReader.cxx:123:14: error: 'class vtkMPASReader::Internal' has no member named 'ncFile'
/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/IO/vtkMPASReader.cxx:125:14: error: 'ncFile' was not declared in this scope
/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/IO/vtkMPASReader.cxx: At global scope:
/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/IO/vtkMPASReader.cxx:175:14: error: 'NcFile' was not declared in this scope
/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/IO/vtkMPASReader.cxx:175:14: note: suggested alternative:
/usr/include/ncFile.h:18:9: note:   'netCDF::NcFile'
/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/IO/vtkMPASReader.cxx:175:22: error: 'ncFile' was not declared in this scope
/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/IO/vtkMPASReader.cxx:175:30: error: 'NcToken' was not declared in this scope
/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/IO/vtkMPASReader.cxx:175:42: error: expression list treated as compound expression in initializer [-fpermissive]
/scratch/portage/sci-visualization/paraview-3.14.1-r2/work/ParaView-3.14.1-Source/VTK/IO/vtkMPASReader.cxx:176:1: error: expected ',' or ';' before '{' token
make[2]: *** [VTK/IO/CMakeFiles/vtkIO.dir/vtkMPASReader.cxx.o] Error 1
Comment 8 François Bissey 2012-09-07 11:42:21 UTC
Just a quick note. The compilation problem only occur in the fortran interface. If USE is set to -fortran netcdf-4.1.3 will happily compile and install. I wonder if it is somehow related to bug #348922?
Comment 9 François Bissey 2012-09-13 02:18:56 UTC
I have a very dirty hack. I have talked with people that are actually doing weather research (NZ metservice and New Zealand institute for weather and atmospheric aka NIWA) and all kind of stuff using netCDF. The word is don't use 4.2.
4.1.3 while using hdf5 still use some bits of netcdf3 underneath so porting is non-trivial.
Comment 10 François Bissey 2012-10-04 10:31:10 UTC
OK so this only happens with the fortran interface and hdf5[mpi]. In my case openmpi, I haven't tried other. The problem ultimately is in the generated libtool file where we get the following:

predep_objects=""
postdep_objects="/usr/lib/gcc/x86_64-pc-linux-gnu/4.6.3/../../../../lib64/crti.o /usr/lib/gcc/x86_64-pc-linux-gnu/4.6.3/crtbeginS.o /usr/lib/gcc/x86_64-pc-linux-gnu/4.6.3/crtendS.o /usr/lib/gcc/x86_64-pc-linux-gnu/4.6.3/../../../../lib64/crtn.o"
predeps=""
postdeps="-l -l -L/usr/lib64 -L/usr/lib/gcc/x86_64-pc-linux-gnu/4.6.3 -L/usr/lib/gcc/x86_64-pc-linux-gnu/4.6.3/../../../../lib64 -L/lib/../lib64 -L/usr/lib/../lib64 -L/usr/lib/gcc/x86_64-pc-linux-gnu/4.6.3/../../../../x86_64-pc-linux-gnu/lib -L/usr/lib/gcc/x86_64-pc-linux-gnu/4.6.3/../../.. -lmpi_f90 -lmpi_f77 -lmpi -lopen-rte -lopen-pal -ldl -lnsl -lutil -lgfortran -lm -ldl -lgfortran -lm -lgcc_s -lquadmath -lm -lgcc_s -lpthread -lc -lgcc_s"

# The library search path used internally by the compiler when linking
# a shared library.
compiler_lib_search_path="-L/usr/lib64"

# ### END LIBTOOL TAG CONFIG: FC

Or a variation thereof. I initially had something in "-l -lm -ldl -l -l" in there. So the libtool generation is messed up. Eliminating the "-l " from libtool solve the problem.
Fedora has a patch for configure to deal with this (I presume):
http://pkgs.fedoraproject.org/cgit/netcdf.git/diff/netcdf-postdeps.patch?h=f17&id=b9d7608ce6081b097a9631efeef527238eb9a01e

Is this some kind of bug in autoconf/libtool or more subtle?
Comment 11 Juergen Rose 2012-10-08 10:37:42 UTC
If I try to use the patch from http://pkgs.fedoraproject.org/cgit/netcdf.git/diff/netcdf-postdeps.patch?h=f17&id=b9d7608ce6081b097a9631efeef527238eb9a01e ,
I get now a slot conflict:

root@impala:/usr/local/portage/sci-libs(9)# emerge -vuDN world

These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild     U  ] sci-libs/proj-4.8.0 [4.7.0] USE="java%* -static-libs" 2,968 kB
[ebuild     U  ] net-fs/openafs-kernel-1.6.1-r1 [1.6.1] 0 kB
[ebuild     U  ] net-print/gtklp-1.2.9 [1.2.8a] USE="nls ssl" 0 kB
[ebuild     U  ] net-fs/openafs-1.6.1-r1 [1.6.1] USE="doc kerberos pam" 0 kB
[ebuild     U  ] dev-perl/HTML-Mason-1.500.0 [1.480.0] USE="doc -modperl {-test}" 0 kB
[ebuild     UD ] sci-libs/netcdf-4.1.3::x-portage [4.2.1.1::gentoo] USE="cxx%* doc fortran%* hdf5 -dap* -static-libs (-examples%*) (-hdf%*) (-mpi%*) (-szip%*) (-test%) (-tools%*)" 0 kB
[ebuild     U  ] media-gfx/sane-backends-1.0.23 [1.0.22-r2] USE="doc gphoto2 ipv6 usb -avahi -v4l -xinetd%" SANE_BACKENDS="abaton agfafocus apple artec artec_eplus48u as6e avision bh canon canon630u canon_dr canon_pp cardscan coolscan coolscan2 coolscan3 dc210 dc240 dc25 dell1600n_net dmc epjitsu epson epson2 fujitsu genesys gt68xx hp hp3500 hp3900 hp4200 hp5400 hp5590 hpljm1005 hpsj5s hs2p ibm kodak kodakaio%* kvs1025 kvs20xx kvs40xx%* leo lexmark ma1509 magicolor matsushita microtek microtek2 mustek mustek_pp mustek_usb nec net niash p5 pie pixma plustek plustek_pp qcam ricoh rts8891 s9036 sceptre sharp sm3600 sm3840 snapscan sp15c st400 stv680 tamarack teco1 teco2 teco3 {test} u12 umax umax1220u umax_pp xerox_mfp -pnm" 0 kB
[ebuild     U #] sci-visualization/paraview-3.14.1-r4::science [3.14.1::science] USE="boost cg doc examples ffmpeg gui mpi mysql plugins python theora webkit -coprocessing -gl2ps% -nvcontrol" 0 kB

Total: 8 packages (7 upgrades, 1 downgrade), Size of downloads: 2,968 kB

!!! Multiple package instances within a single package slot have been pulled
!!! into the dependency graph, resulting in a slot conflict:

sci-libs/proj:0

  (sci-libs/proj-4.8.0::gentoo, ebuild scheduled for merge) pulled in by
    (no parents that aren't satisfied by other packages in this slot)

  (sci-libs/proj-4.7.0::gentoo, installed) pulled in by
    <sci-libs/proj-4.8 required by (dev-perl/PDL-2.4.11::gentoo, installed)
    (and 1 more with the same problem)

sci-libs/netcdf:0

  (sci-libs/netcdf-4.1.3::x-portage, ebuild scheduled for merge) pulled in by
    ~sci-libs/netcdf-4.1.3[cxx,hdf5] required by (sci-visualization/paraview-3.14.1-r4::science, ebuild scheduled for merge)

  (sci-libs/netcdf-4.2.1.1::gentoo, installed) pulled in by
    >=sci-libs/netcdf-4.2 required by (sci-libs/netcdf-cxx-4.2::gentoo, installed)


If I delete netcdf-cxx, the slot conflicts remains, because depends dev-lang/gdl-0.9.2-r2 on netcdf-cxx:

root@impala:/usr/local/portage/sci-libs(11)# emerge -vuDNt world

These are the packages that would be merged, in reverse order:

Calculating dependencies... done!
[nomerge       ] dev-lang/gdl-0.9.2-r2  USE="fftw hdf hdf5 imagemagick netcdf openmp postscript proj python wxwidgets -grib -gshhs -static-libs {-test} -udunits" 
[ebuild  N     ]  sci-libs/netcdf-cxx-4.2  USE="examples -static-libs" 386 kB
[nomerge       ] media-gfx/xsane-0.998-r1  USE="gimp jpeg lcms nls ocr png tiff" 
...
[ebuild     UD ]  sci-libs/netcdf-4.1.3::x-portage [4.2.1.1::gentoo] USE="cxx%* doc fortran%* hdf5 -dap* -static-libs (-examples%*) (-hdf%*) (-mpi%*
...
!!! Multiple package instances within a single package slot have been pulled
!!! into the dependency graph, resulting in a slot conflict:

sci-libs/proj:0

  (sci-libs/proj-4.8.0::gentoo, ebuild scheduled for merge) pulled in by
    (no parents that aren't satisfied by other packages in this slot)

  (sci-libs/proj-4.7.0::gentoo, installed) pulled in by
    <sci-libs/proj-4.8 required by (dev-perl/PDL-2.4.11::gentoo, installed)
    (and 1 more with the same problem)

sci-libs/netcdf:0

  (sci-libs/netcdf-4.1.3::x-portage, ebuild scheduled for merge) pulled in by
    ~sci-libs/netcdf-4.1.3[cxx,hdf5] required by (sci-visualization/paraview-3.14.1-r4::science, ebuild scheduled for merge)

  (sci-libs/netcdf-4.2.1.1::gentoo, installed) pulled in by
    >=sci-libs/netcdf-4.2 required by (sci-libs/netcdf-cxx-4.2::gentoo, ebuild scheduled for merge)


If I then remove all netcdf-4.2*.ebuild from my /usr/local/portage/sci-libs/netcdf overlay, the slot conflict disappears, but 'emerge netcdf' fails with the old error:

>>> Emerging (1 of 6) sci-libs/netcdf-4.1.3 from x-portage
 * netcdf-4.1.3.tar.gz SHA256 SHA512 WHIRLPOOL size ;-) ...            [ ok ]
...
/var/tmp/portage/sci-libs/netcdf-4.1.3/work/netcdf-4.1.3/include/netcdf.h:1448:1: note: expected 'long long int *' but argument is of type 'int *'
/var/tmp/portage/sci-libs/netcdf-4.1.3/work/netcdf-4.1.3/fortran/fort-nc4.c: In function 'nf_get_var_int64_':
/var/tmp/portage/sci-libs/netcdf-4.1.3/work/netcdf-4.1.3/fortran/fort-nc4.c:223:1: warning: passing argument 3 of 'nc_get_var_longlong' from incompatible pointer type [enabled by default]
/var/tmp/portage/sci-libs/netcdf-4.1.3/work/netcdf-4.1.3/include/netcdf.h:1539:1: note: expected 'long long int *' but argument is of type 'int *'
/bin/sh ../libtool --tag=FC   --mode=link mpif90  -O2 -pipe  -version-number 5:1:0  -Wl,-O1 -Wl,--as-needed -o libnetcdff.la -rpath /usr/lib64 fort-attio.lo fort-control.lo fort-dim.lo fort-genatt.lo fort-geninq.lo fort-genvar.lo fort-lib.lo fort-misc.lo fort-v2compat.lo fort-vario.lo fort-var1io.lo fort-varaio.lo fort-varmio.lo fort-varsio.lo fort-nc4.lo ../liblib/libnetcdf.la ../f90/libnetcdff90.la -lsz -lhdf5_hl -lhdf5 -lm -lz -lcurl 
libtool: link: mpif90 -shared  -fPIC  .libs/fort-attio.o .libs/fort-control.o .libs/fort-dim.o .libs/fort-genatt.o .libs/fort-geninq.o .libs/fort-genvar.o .libs/fort-lib.o .libs/fort-misc.o .libs/fort-v2compat.o .libs/fort-vario.o .libs/fort-var1io.o .libs/fort-varaio.o .libs/fort-varmio.o .libs/fort-varsio.o .libs/fort-nc4.o  -Wl,--whole-archive ../f90/.libs/libnetcdff90.a -Wl,--no-whole-archive  -Wl,-rpath -Wl,/var/tmp/portage/sci-libs/netcdf-4.1.3/work/netcdf-4.1.3_build/liblib/.libs -Wl,--as-needed ../liblib/.libs/libnetcdf.so -lsz -lhdf5_hl -lhdf5 -lz -lcurl -L/usr/lib64 -L/usr/lib/gcc/x86_64-pc-linux-gnu/4.6.3 -l -L/usr/lib/gcc/x86_64-pc-linux-gnu/4.6.3/../../../../lib64 -L/lib/../lib64 -L/usr/lib/../lib64 -L/usr/lib/gcc/x86_64-pc-linux-gnu/4.6.3/../../../../x86_64-pc-linux-gnu/lib -L/usr/lib/gcc/x86_64-pc-linux-gnu/4.6.3/../../.. /usr/lib64/libmpi_f90.so /usr/lib64/libmpi_f77.so /usr/lib64/libmpi.so -lrt -lnsl -lutil -lhwloc -ldl /usr/lib/gcc/x86_64-pc-linux-gnu/4.6.3/libgfortran.so /usr/lib/gcc/x86_64-pc-linux-gnu/4.6.3/libquadmath.so -lm -lpthread -lc -lgcc_s  -O2 -Wl,-O1   -pthread -Wl,-soname -Wl,libnetcdff.so.5 -o .libs/libnetcdff.so.5.1.0
/usr/lib/gcc/x86_64-pc-linux-gnu/4.6.3/../../../../x86_64-pc-linux-gnu/bin/ld: cannot find -l-L/usr/lib/gcc/x86_64-pc-linux-gnu/4.6.3/../../../../lib64
collect2: ld returned 1 exit status
make[3]: *** [libnetcdff.la] Error 1
Comment 12 Juergen Rose 2012-10-08 10:40:17 UTC
Created attachment 325980 [details]
/usr/local/portage/sci-libs/netcdf/netcdf-4.1.3.ebuild

The ebuild I used.
Comment 13 Juergen Rose 2012-10-08 10:41:18 UTC
Created attachment 325982 [details]
/usr/local/portage/sci-libs/netcdf/files/netcdf-postdeps.patch

The patch again.
Comment 14 François Bissey 2012-10-08 10:54:22 UTC
The patch from fedora cannot work as is. We run autoreconfig in src_prepare so the configure script is regenerated however you patched it. You could possibly try to apply it - or an updated version of it after autotools-utils_src_prepare but I don't think we can guaranty that a patch to configure will apply generally after autoreconfig.
Possibly you could try
sed -i 's:test $p = "-R":test $p = "-R" || test $p = "-l":' configure
after autotools-utils_src_prepare. I am working on something else right now so cannot test.
Comment 15 Juergen Rose 2012-10-08 12:21:45 UTC
Thanks Francois,

the patch corresonding to Comment 14 works for me, at least on three systems.
Comment 16 Juergen Rose 2012-10-08 12:23:06 UTC
Created attachment 325988 [details]
/usr/local/portage/sci-libs/netcdf/netcdf-4.1.3.ebuild

netcdf-4.1.3.ebuild corresponding to Comment 14
Comment 17 François Bissey 2012-10-08 19:14:17 UTC
It's extremely dirty but that's the best workaround I found so far.
Comment 18 Christoph Junghans gentoo-dev 2013-08-21 17:52:28 UTC
+  21 Aug 2013; Christoph Junghans <ottxor@gentoo.org> netcdf-4.1.3.ebuild:
+  fixed linking issue (bug #433647)
+
Comment 19 Juergen Rose 2013-12-01 18:18:48 UTC
Now 'emerge netcdf' fails with the netcdf with:
...
/var/tmp/portage/sci-libs/netcdf-4.1.3/work/netcdf-4.1.3/man4/netcdf-f90.texi:2085: warning: @item missing argument
/var/tmp/portage/sci-libs/netcdf-4.1.3/work/netcdf-4.1.3/man4/netcdf-f90.texi:6982: raising the section level of @unnumberedsubsec which is too low
mv: cannot move ‘.am23616/netcdf-f90.info’ to ‘.//var/tmp/portage/sci-libs/netcdf-4.1.3/work/netcdf-4.1.3/man4/’: No such file or directory
Makefile:484: recipe for target '/var/tmp/portage/sci-libs/netcdf-4.1.3/work/netcdf-4.1.3/man4/netcdf-f90.info' failed
make: *** [/var/tmp/portage/sci-libs/netcdf-4.1.3/work/netcdf-4.1.3/man4/netcdf-f90.info] Error 1
make: Leaving directory '/var/tmp/portage/sci-libs/netcdf-4.1.3/work/netcdf-4.1.3_build/man4'
 * ERROR: sci-libs/netcdf-4.1.3::x-portage failed (compile phase):
 *   emake failed
Comment 20 Justin Lecher (RETIRED) gentoo-dev 2013-12-01 18:21:03 UTC
(In reply to Juergen Rose from comment #19)
> Now 'emerge netcdf' fails with the netcdf with:
> ...
> /var/tmp/portage/sci-libs/netcdf-4.1.3/work/netcdf-4.1.3/man4/netcdf-f90.
> texi:2085: warning: @item missing argument
> /var/tmp/portage/sci-libs/netcdf-4.1.3/work/netcdf-4.1.3/man4/netcdf-f90.
> texi:6982: raising the section level of @unnumberedsubsec which is too low
> mv: cannot move ‘.am23616/netcdf-f90.info’ to
> ‘.//var/tmp/portage/sci-libs/netcdf-4.1.3/work/netcdf-4.1.3/man4/’: No such
> file or directory
> Makefile:484: recipe for target
> '/var/tmp/portage/sci-libs/netcdf-4.1.3/work/netcdf-4.1.3/man4/netcdf-f90.
> info' failed
> make: ***
> [/var/tmp/portage/sci-libs/netcdf-4.1.3/work/netcdf-4.1.3/man4/netcdf-f90.
> info] Error 1
> make: Leaving directory
> '/var/tmp/portage/sci-libs/netcdf-4.1.3/work/netcdf-4.1.3_build/man4'
>  * ERROR: sci-libs/netcdf-4.1.3::x-portage failed (compile phase):
>  *   emake failed

please open a new bug with full build.log. Looks like a different issue.